unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OpenGL, StdCtrls;

type
  line = array[1..3] of Double;
  mas = array[1..2] of line;
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure SetDCPixelFormat (hdc: HDC);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  hrc: HGLRC;
  DC:HDC;
  v:integer;

  x2,y2:double;
  x:mas;
implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
   Randomize;
   DC:=GetDC(Handle);
   SetDCPixelFormat(DC);
   hrc:= wglCreateContext(DC);
   wglMakeCurrent(DC, hrc);
   x[1,1]:=-0.7;                      //    
   x[1,2]:=0;
   x[1,3]:=0.7;
   x[2,1]:=-0.7;
   x[2,2]:=0.7;
   x[2,3]:=-0.7;
   x2:=-0.7;                         //       
   y2:=0.7;
end;

procedure TFOrm1.SetDCPixelFormat (hdc: HDC);
 var pfd: TPixelFormatDescriptor; nPixelFormat: Integer;
begin
   FillChar (pfd, SizeOf (pfd), 0);
  nPixelFormat:= ChoosePixelFormat (hdc, @pfd);
  SetPixelFormat (hdc, nPixelFormat, @pfd);
end;

procedure TForm1.FormPaint(Sender: TObject); var i:integer;
begin
  x2:=-0.3;
  y2:=0;
  glClearColor(0.0,0.0,0,0);
  glClear (GL_COLOR_BUFFER_BIT);
  glColor3f (1.0, 0, 0);
  glPointSize(1);                  //   
  glBegin (GL_POINTS);
    glVertex2f (x[1,1],x[2,1]);
    glVertex2f (x[1,2],x[2,2]);
    glVertex2f (x[1,3],x[2,3]);
  glEnd;

for i:=1 to 500000 do        //    500000  
begin
v:=Random(3)+1;            //    
if v=1 then
 begin
   x2:=(x2+x[1,1])/2;
   y2:=(y2+x[2,1])/2;
 end;
if v=2 then
 begin
   x2:=(x2+x[1,2])/2;
   y2:=(y2+x[2,2])/2;
 end;
if v=3 then
 begin
   x2:=(x2+x[1,3])/2;
   y2:=(y2+x[2,3])/2;
 end;
 glBegin(GL_POINTS);            //  
 glColor(1,1,0.5);
 glVertex2f (x2,y2);
 glEnd;
 end;
 SwapBuffers(DC);
 wglMakeCurrent (0, 0);
end;


end.
